// Jalview Priliminary applet-generation code.
// author: Bob Hanson hansonr@stolaf.edu

Jalview = { 
	jvid : 0 
}

$(document).ready(function() {
	if (document.location.href.toLowerCase().indexOf("_use=java") < 0)
		Jalview.processAllAppletElements(self.JalviewInfo);
});

 
Jalview.processAllAppletElements = function(PageInfo) {
 	var applets = document.getElementsByTagName("applet") || document.getElementsByTagName("jvapplet");
	var apps=[];
 	for (var i = 0; i < applets.length; i++)
		apps[i] = applets[i];
 	for (var i = 0; i < apps.length; i++) {
 		Jalview.processAppletElement(apps[i], PageInfo);
 	}
}
 
Jalview.processAppletElement = function(element, UserInfo) {
	
	// This code is specifically for processing the <applet> or <jvapplet> tag.
	
	// To set Jalview application tags, use Info.args="......."

	// To set preferences, use "jalview_" prefix with all-upper-case names:

	//Info.jalview_SCREEN_X= 10,Info.jalview_SCREEN_Y= 10;
	//Info.jalview_EMBEDDED= true;
	//Info.jalview_SCREEN_WIDTH = 400;
	//Info.jalview_SCREEN_HEIGHT = 100;
	
var text = element.outerHTML;
var code = element.getAttribute("code");
var parent = element.parentElement;
if (code != "jalview.bin.JalviewLite" && text.indexOf("<applet") == 0) {
	return;
}

 	var Info = {
	code: null,
	main: "jalview.bin.Jalview",
	core: "NONE",
	resourcePath: "examples",
	readyFunction: null,
	serverURL: 'https://chemapps.stolaf.edu/jmol/jsmol/php/jsmol.php',
	j2sPath: 'swingjs/j2s',
	console:'sysout',
	startButton:'Start Jalview',
	hideDesktop:true,
	embedInternalFrames:false,
	idPrefix:'%ID%',
	allowjavascript: true
	}

 	var args = Info.args = text.replace(/[\n\t]/g, " ").replace("<jvapplet","<applet").split("<param ");

 	// overwrite default parameters with UserInfo (global JalviewInfo):
 
	if (UserInfo) {
		for (var i in UserInfo) {
			Info[i] = UserInfo[i];
		}
	}

	// generate name/value pairs for parameters in Applet tag

	Info.j2sAppletID = Info.j2sAppletID 
		|| element.getAttribute("name") 
		|| element.getAttribute("id") 
		|| Info.idPrefix.replace(/%ID%/g, "jalview" + ++Jalview.jvid);
	
	
	var addParam = function(key,value) {
		args.push("name=\"" + key + "\" value=\"" + value + "\""); 
	}
	
	
	for (var i in Info) {
		var v = ("" + Info[i] || "null").replace(/\"/g,"'");
		addParam("Info." + i, v);
	}
		
		
	
	element.JalviewInfo = Info;
	var btn = document.createElement("button");
	btn.appletElement = element;
	var a = element.getAttribute("width");
	btn.style.width = (a || 140) + "px";
	a = element.getAttribute("height");
	btn.style.height = (a || 25) + "px";
	btn.jvparent = parent;
	if (Info.startButton) {
		btn.innerHTML = Info.startButton;
		parent.replaceChild(btn, element); 
		$(btn).click(Jalview.doStartJalview);
	} else {
	 	parent.removeElement(element);
		Jalview.doStartJalview({target:btn});
	}
}
 


Jalview.doStartJalview = function(e) {
 	var element = e.target.appletElement;
var parent = e.target.jvparent;
	var Info = element.JalviewInfo;
	var id = Info.j2sAppletID;
	var d = document.createElement("div");
	d.id = id + "-desktop-div";
	if (Info.hideDesktop) {
		d.style.display = "none";
		d.style.width = d.style.height = "0px";
	} else {
		d.style.width = "300px", d.style.height = "70px";
	}
	parent.appendChild(d);
	d = document.createElement("div");
	d.id = id + "-alignment-div";
	if (Info.embedInternalFrames) {
// TODO
	} else {
		d.style.display = "none";
		d.style.width = d.style.height = "0px";
	}
	SwingJS.getApplet(id, Info);
	document.title = id;
	e.target.style.visibility="hidden";
}

